def busort(v):
	size = len(v)
	# number of necessary iterations
	niter = 0

	while size > 1:
		for i in range(0, size - 1):
			niter = niter + 1
			if v[i] > v[i + 1]:
				tmp = v[i]
				v[i] = v[i + 1]
				v[i + 1]  = tmp
			
			# 
		size = size - 1

	return niter

# Optimization. 
# After each swap operation, it stores the index of the last position that has been swapped
# so that the outer cycle can stop earlier.

def busort2(v):
	size = len(v)
	# number of necessary iterations
	niter = 0

	while size > 1:
		size = size - 1
		for i in range(0, size):
			niter = niter + 1
			if v[i] > v[i + 1]:
				tmp = v[i]
				v[i] = v[i + 1]
				v[i + 1]  = tmp
				# store last swapped index
				size = i + 1
			
			# 

	return niter

import random

def test():
	for vett in range(0, 20):
		v = []
		# creo una lista con un numero casuale di elementi tra 10 e 20
		for i in range(0, random.randint(10, 20)):
			# genero un numero casuale tra -100 e 100 usando randint dal modulo random
			n = random.randint(-100, 100)
			# lo aggiungo al vettore v
			v.append(n)

		print("\n* vettore %d: di dimensione %d: " % ((vett + 1),  len(v)),  v)
		# copio v per riordinarlo poi con la busort2:
		v2 = v[:] 

		niter = busort(v)
		print("  bubble sort versione1 ha richiesto %d iterazioni" % niter, v)
		
		niter = busort2(v2)
		print("  bubble sort versione2 ha richiesto %d iterazioni" % niter, v2)








