# ------------------------------------------ 1 ------------------------------------
#
# Fattoriale ricorsivo
#
def fact(n):
	"""calcola il fattoriale di n in modo ricorsivo"""
	if n == 0:
		return 1
	else:
		return n * fact(n-1)


# ------------------------------------------ 2 ------------------------------------
#
# due funzioni per la copia profonda di liste annidate
# 
def cp(alist, ret):
  
  for i in range(0, len(alist)):
    try:
      if len(alist[i]) > 0:
        l = list()
        ret.append(l)
        cp(alist[i], l)
    #    print("alist is list", alist[i])
    except TypeError:
      ret.append(alist[i])
   #   print("appending ", alist[i])

  return ret

# funzione principale da chiamare

def deepcopy(al):
  """Accetta in ingresso una lista annidata di qualsiasi livello e restituisce 
  in uscita una sua copia profonda"""
  ret = []
  cp(al, ret)
  return ret

# ecco una lista con cui fare il test.

li1 = [[[1, 2], [4, 5]], [[1, 2], [4, 5]], 4, [0, 90, 100, [12, 2, [-3, 3]]]]

# ------------------------------------------ 3 ------------------------------------
#
# MCD ricorsivo
# 

def mcd(a, b):
	if b == 0:
		return a
	else:
		return mcd_r(b, a % b)
		
# ------------------------------------------ 4 ------------------------------------
#
# Successione di Fibonacci
# 	
def fibo(n):
	if n == 0:
		return 0
	elif n == 1:
		return 1
	else:
		return fibo(n-1) + fibo(n-2)




