recursion_cnt = 0


# Fonde le due meta` individuate da left, center e right 
# ordinando gli elementi
#
def merge (vect, left, center, right):
    i = left
    j = center + 1

    # define temporary ordered vector
    temp = []

    # scommentare per tracciare l'esecuzione 
    print("merge() entering: ", vect[left:center+1], vect[center+1:right+1], left, center, right)

    # confronto elementi appartenenti alla prima meta` con elementi
    # appartenenti alla seconda meta`. 
    # All'interno di ciascuna meta` infatti gli elementi sono gia` 
    # in ordine.
    #
    while i <= center and j <= right:
        if vect[i] <= vect[j]:
            temp.append(vect[i])
            i = i + 1;
        else:
            temp.append(vect[j])
            j = j + 1
        
    # aggiungo in coda gli elementi eventualmente non copiati nel ciclo precedente
    # 
    while i <= center:
        temp.append(vect[i])
        i = i + 1
 
    # aggiungo in coda gli elementi eventualmente non copiati nel primo ciclo
    # 
    while j <= right:
        temp.append(vect[j])
        j = j + 1

    # nello stesso vettore di ingresso salvo gli elementi in temp,
    # che sono stati ordinati da left a right.
    # Il range parte da left.
    for index in range(left, right + 1):
        vect[index] = temp[index - left]
    
    # scommentare per tracciare l'esecuzione 
    print("merge(): leaving: ", vect, left, center, right)
    
    return 

# Funzione ricorsiva per il riordinamento di un vettore vect da left a right
# In questa versione, right deve essere len(vect) - 1, ovvero l'indice del suo ultimo elemento, non
# la lunghezza totale del vettore.
#      
def mergesort(vect, left, right):

#   print("merge sort call ", recursion_cnt)
#   recursion_cnt = recursion_cnt + 1
    if left  < right:
    	# importante: //
        center = (left + right) // 2 
    
        # scommentare per tracciare l'esecuzione 
        print("mergesort: ", vect, left, right)        
        mergesort(vect, left, center)
        mergesort(vect, center+1, right)
        merge(vect, left, center, right)

# funzione principale da chiamare dalla console con il vettore da ordinare
# come parametro
#
def sort(v):
	"""Riordina il vettore passato come parametro in ingresso 
	mediante l'algoritmo merge sort"""

	left = 0
	right = len(v) - 1
	mergesort(v, left, right)



